diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/emlsr-manager.h ns-3.44/src/wifi/model/eht/emlsr-manager.h
--- ns-3.43/src/wifi/model/eht/emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/emlsr-manager.h	2025-03-09 16:55:49.787372600 -0700
@@ -16,8 +16,10 @@
 #include "ns3/wifi-phy-operating-channel.h"
 
 #include <map>
+#include <memory>
 #include <optional>
 #include <set>
+#include <string_view>
 #include <utility>
 
 class EmlsrCcaBusyTest;
@@ -30,7 +32,46 @@
 class WifiMpdu;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
+ * Base struct for EMLSR Main PHY switch traces.
+ */
+struct EmlsrMainPhySwitchTrace
+{
+    virtual ~EmlsrMainPhySwitchTrace() = default;
+
+    /// @return the name of this instance
+    virtual std::string_view GetName() const = 0;
+
+    /// @return a pointer to the clone of this object
+    virtual std::shared_ptr<EmlsrMainPhySwitchTrace> Clone() const = 0;
+
+    std::optional<uint8_t> fromLinkId; //!< ID of the link the main PHY is moving from (if any)
+    uint8_t toLinkId{WIFI_LINKID_UNDEFINED}; //!< ID of the link the main PHY is moving to
+};
+
+/**
+ * Implementation for the EMLSR Main PHY switch trace base struct. Child structs are inherited
+ * from this implementation according to the CRTP idiom and must define a static string_view
+ * member containing the name of the child.
+ */
+template <class T>
+struct EmlsrMainPhySwitchTraceImpl : public EmlsrMainPhySwitchTrace
+{
+    /// @copydoc ns3::EmlsrMainPhySwitchTrace::GetName
+    std::string_view GetName() const override
+    {
+        return T::m_name;
+    }
+
+    /// @copydoc ns3::EmlsrMainPhySwitchTrace::Clone
+    std::shared_ptr<EmlsrMainPhySwitchTrace> Clone() const override
+    {
+        return std::shared_ptr<EmlsrMainPhySwitchTrace>(new T(static_cast<const T&>(*this)));
+    }
+};
+
+/**
+ * @ingroup wifi
  *
  * EmlsrManager is an abstract base class defining the API that EHT non-AP MLDs
  * with EMLSR activated can use to handle the operations on the EMLSR links
@@ -41,9 +82,12 @@
     friend class ::EmlsrCcaBusyTest;
 
   public:
+    /// The aMediumSyncThreshold defined by Sec. 35.3.16.18.1 of 802.11be D4.0
+    static constexpr uint16_t MEDIUM_SYNC_THRESHOLD_USEC = 72;
+
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     EmlsrManager();
@@ -52,31 +96,31 @@
     /**
      * Set the wifi MAC. Note that it must be the MAC of an EHT non-AP MLD.
      *
-     * \param mac the wifi MAC
+     * @param mac the wifi MAC
      */
     void SetWifiMac(Ptr<StaWifiMac> mac);
 
     /**
      * Set the Transition Timeout advertised by the associated AP with EMLSR activated.
      *
-     * \param timeout the advertised Transition Timeout
+     * @param timeout the advertised Transition Timeout
      */
     void SetTransitionTimeout(Time timeout);
 
     /**
-     * \return the Transition Timeout, if advertised by the associated AP
+     * @return the Transition Timeout, if advertised by the associated AP
      */
     std::optional<Time> GetTransitionTimeout() const;
 
     /**
      * Set the duration of the MediumSyncDelay timer.
      *
-     * \param duration the duration of the MediumSyncDelay timer
+     * @param duration the duration of the MediumSyncDelay timer
      */
     void SetMediumSyncDuration(Time duration);
 
     /**
-     * \return the duration of the MediumSyncDelay timer
+     * @return the duration of the MediumSyncDelay timer
      */
     Time GetMediumSyncDuration() const;
 
@@ -84,12 +128,12 @@
      * Set the Medium Synchronization OFDM ED threshold (dBm) to use while the MediumSyncDelay
      * timer is running.
      *
-     * \param threshold the threshold in dBm (ranges from -72 to -62 dBm)
+     * @param threshold the threshold in dBm (ranges from -72 to -62 dBm)
      */
     void SetMediumSyncOfdmEdThreshold(int8_t threshold);
 
     /**
-     * \return the Medium Synchronization OFDM ED threshold (dBm) to use while the MediumSyncDelay
+     * @return the Medium Synchronization OFDM ED threshold (dBm) to use while the MediumSyncDelay
      * timer is running.
      */
     int8_t GetMediumSyncOfdmEdThreshold() const;
@@ -98,19 +142,19 @@
      * Set the maximum number of TXOPs a non-AP STA is allowed to attempt to initiate while
      * the MediumSyncDelay timer is running. No value indicates no limit.
      *
-     * \param nTxops the maximum number of TXOPs a non-AP STA is allowed to attempt to
+     * @param nTxops the maximum number of TXOPs a non-AP STA is allowed to attempt to
      *               initiate while the MediumSyncDelay timer is running
      */
     void SetMediumSyncMaxNTxops(std::optional<uint8_t> nTxops);
 
     /**
-     * \return the maximum number of TXOPs a non-AP STA is allowed to attempt to initiate while
+     * @return the maximum number of TXOPs a non-AP STA is allowed to attempt to initiate while
      * the MediumSyncDelay timer is running. No value indicates no limit.
      */
     std::optional<uint8_t> GetMediumSyncMaxNTxops() const;
 
     /**
-     * \return the ID of main PHY (position in the vector of PHYs held by WifiNetDevice)
+     * @return the ID of main PHY (position in the vector of PHYs held by WifiNetDevice)
      */
     uint8_t GetMainPhyId() const;
 
@@ -118,13 +162,13 @@
      * Take actions to enable EMLSR mode on the given set of links, if non-empty, or
      * disable EMLSR mode, otherwise.
      *
-     * \param linkIds the IDs of the links on which EMLSR mode should be enabled
+     * @param linkIds the IDs of the links on which EMLSR mode should be enabled
      *                (empty to disable EMLSR mode)
      */
     void SetEmlsrLinks(const std::set<uint8_t>& linkIds);
 
     /**
-     * \return the set of links on which EMLSR mode is enabled
+     * @return the set of links on which EMLSR mode is enabled
      */
     const std::set<uint8_t>& GetEmlsrLinks() const;
 
@@ -132,12 +176,12 @@
      * Set the member variable indicating whether the state of the CAM should be reset when
      * the main PHY switches channel and operates on the link associated with the CAM.
      *
-     * \param enable whether the CAM state should be reset
+     * @param enable whether the CAM state should be reset
      */
     void SetCamStateReset(bool enable);
 
     /**
-     * \return the value of the member variable indicating whether the state of the CAM should be
+     * @return the value of the member variable indicating whether the state of the CAM should be
      * reset when the main PHY switches channel and operates on the link associated with the CAM.
      */
     bool GetCamStateReset() const;
@@ -146,9 +190,9 @@
      * Notify that an UL TXOP is gained on the given link by the given AC. This method has to
      * determine whether to start the UL TXOP or release the channel.
      *
-     * \param linkId the ID of the given link
-     * \param aci the index of the given AC
-     * \return a pair consisting of a boolean value indicating whether the UL TXOP can be started
+     * @param linkId the ID of the given link
+     * @param aci the index of the given AC
+     * @return a pair consisting of a boolean value indicating whether the UL TXOP can be started
      *         and a Time value indicating the delay after which the EMLSR client must restart
      *         channel access (if needed) in case the UL TXOP is not started
      */
@@ -157,12 +201,12 @@
     /**
      * Set the member variable indicating whether Aux PHYs are capable of transmitting PPDUs.
      *
-     * \param capable whether Aux PHYs are capable of transmitting PPDUs
+     * @param capable whether Aux PHYs are capable of transmitting PPDUs
      */
     void SetAuxPhyTxCapable(bool capable);
 
     /**
-     * \return whether Aux PHYs are capable of transmitting PPDUs
+     * @return whether Aux PHYs are capable of transmitting PPDUs
      */
     bool GetAuxPhyTxCapable() const;
 
@@ -170,13 +214,13 @@
      * Set the member variable indicating whether in-device interference is such that a PHY cannot
      * decode anything and cannot decrease the backoff counter when another PHY is transmitting.
      *
-     * \param enable whether in-device interference is such that a PHY cannot decode anything
+     * @param enable whether in-device interference is such that a PHY cannot decode anything
      *               and cannot decrease the backoff counter when another PHY is transmitting
      */
     void SetInDeviceInterference(bool enable);
 
     /**
-     * \return whether in-device interference is such that a PHY cannot decode anything and cannot
+     * @return whether in-device interference is such that a PHY cannot decode anything and cannot
      *         decrease the backoff counter when another PHY is transmitting
      */
     bool GetInDeviceInterference() const;
@@ -184,42 +228,70 @@
     /**
      * Notify the reception of a management frame addressed to us.
      *
-     * \param mpdu the received MPDU
-     * \param linkId the ID of the link over which the MPDU was received
+     * @param mpdu the received MPDU
+     * @param linkId the ID of the link over which the MPDU was received
      */
     void NotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
 
     /**
      * Notify the reception of an initial Control frame on the given link.
      *
-     * \param linkId the ID of the link on which the initial Control frame was received
+     * @param linkId the ID of the link on which the initial Control frame was received
      */
     void NotifyIcfReceived(uint8_t linkId);
 
     /**
      * Notify the start of an UL TXOP on the given link
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void NotifyUlTxopStart(uint8_t linkId);
 
     /**
+     * Notify that RTS transmission is starting on the given link.
+     *
+     * @param linkId the ID of the given link
+     * @param rts the RTS being transmitted
+     * @param txVector the TXVECTOR used to transmit the RTS
+     */
+    virtual void NotifyRtsSent(uint8_t linkId,
+                               Ptr<const WifiPsdu> rts,
+                               const WifiTxVector& txVector);
+
+    /**
+     * Notify that protection (if required) is completed and data frame exchange can start
+     * on the given link.
+     *
+     * @param linkId the ID of the given link
+     */
+    void NotifyProtectionCompleted(uint8_t linkId);
+
+    /**
      * Notify the end of a TXOP on the given link.
      *
-     * \param linkId the ID of the given link
-     * \param ulTxopNotStarted whether this is a notification of the end of an UL TXOP that did
+     * @param linkId the ID of the given link
+     * @param ulTxopNotStarted whether this is a notification of the end of an UL TXOP that did
      *                      not even start (no frame transmitted)
-     * \param ongoingDlTxop whether a DL TXOP is ongoing on the given link (if true, this is
+     * @param ongoingDlTxop whether a DL TXOP is ongoing on the given link (if true, this is
      *                      a notification of the end of an UL TXOP)
      */
     void NotifyTxopEnd(uint8_t linkId, bool ulTxopNotStarted = false, bool ongoingDlTxop = false);
 
     /**
+     * Notify that an STA affiliated with the EMLSR client is causing in-device interference
+     * for the given amount of time.
+     *
+     * @param linkId the ID of the link on which the STA is operating
+     * @param duration the duration of the in-device interference
+     */
+    virtual void NotifyInDeviceInterferenceStart(uint8_t linkId, Time duration);
+
+    /**
      * Check whether the MediumSyncDelay timer is running for the STA operating on the given link.
      * If so, returns the time elapsed since the timer started.
      *
-     * \param linkId the ID of the given link
-     * \return the time elapsed since the MediumSyncDelay timer started, if this timer is running
+     * @param linkId the ID of the given link
+     * @return the time elapsed since the MediumSyncDelay timer started, if this timer is running
      *         for the STA operating on the given link
      */
     std::optional<Time> GetElapsedMediumSyncDelayTimer(uint8_t linkId) const;
@@ -229,7 +301,7 @@
      * actions. This function must not be called when the MediumSyncDelay timer is not running
      * on the given link.
      *
-     * \param linkId the ID of the link associated with the MediumSyncDelay timer to cancel
+     * @param linkId the ID of the link associated with the MediumSyncDelay timer to cancel
      */
     void CancelMediumSyncDelayTimer(uint8_t linkId);
 
@@ -238,7 +310,7 @@
      * timer is running. This function must not be called when the MediumSyncDelay timer is not
      * running on the given link.
      *
-     * \param linkId the ID of the link on which a new TXOP attempt may be carried out
+     * @param linkId the ID of the link on which a new TXOP attempt may be carried out
      */
     void DecrementMediumSyncDelayNTxops(uint8_t linkId);
 
@@ -249,7 +321,7 @@
      * attempt is successful. This function must not be called when the MediumSyncDelay timer is
      * not running on the given link.
      *
-     * \param linkId the ID of the link for which the counter of the TXOP attempts is reset
+     * @param linkId the ID of the link for which the counter of the TXOP attempts is reset
      */
     void ResetMediumSyncDelayNTxops(uint8_t linkId);
 
@@ -257,34 +329,44 @@
      * Return whether no more TXOP attempt is allowed on the given link. This function must not
      * be called when the MediumSyncDelay timer is not running on the given link.
      *
-     * \param linkId the ID of the link on which a new TXOP attempt may be carried out
-     * \return whether no more TXOP attempt on the given link is allowed
+     * @param linkId the ID of the link on which a new TXOP attempt may be carried out
+     * @return whether no more TXOP attempt on the given link is allowed
      */
     bool MediumSyncDelayNTxopsExceeded(uint8_t linkId);
 
+    /**
+     * Check whether a PPDU that may be an ICF is being received on the given link. If so, return
+     * true along with the time to wait to know more information about the PPDU being received.
+     * Otherwise, return false.
+     *
+     * @param linkId the ID of the given link
+     * @return a pair indicating whether a PPDU that may be an ICF is being received on the link
+     */
+    std::pair<bool, Time> CheckPossiblyReceivingIcf(uint8_t linkId) const;
+
   protected:
     void DoDispose() override;
 
     /**
      * Allow subclasses to take actions when the MAC is set.
      *
-     * \param mac the wifi MAC
+     * @param mac the wifi MAC
      */
     virtual void DoSetWifiMac(Ptr<StaWifiMac> mac);
 
     /**
-     * \return the MAC of the non-AP MLD managed by this EMLSR Manager.
+     * @return the MAC of the non-AP MLD managed by this EMLSR Manager.
      */
     Ptr<StaWifiMac> GetStaMac() const;
 
     /**
-     * \param linkId the ID of the given link
-     * \return the EHT FrameExchangeManager attached to the non-AP STA operating on the given link
+     * @param linkId the ID of the given link
+     * @return the EHT FrameExchangeManager attached to the non-AP STA operating on the given link
      */
     Ptr<EhtFrameExchangeManager> GetEhtFem(uint8_t linkId) const;
 
     /**
-     * \return the ID of the link on which the EML Operating Mode Notification frame has to be sent
+     * @return the ID of the link on which the EML Operating Mode Notification frame has to be sent
      */
     virtual uint8_t GetLinkToSendEmlOmn() = 0;
 
@@ -292,21 +374,21 @@
      * A previous EML Operating Mode Notification frame was dropped. Ask the subclass whether
      * the frame needs to be re-sent on the given link (if any).
      *
-     * \param mpdu the dropped MPDU that includes the EML Operating Mode Notification frame
-     * \return the ID of the link over which to re-send the frame, if needed
+     * @param mpdu the dropped MPDU that includes the EML Operating Mode Notification frame
+     * @return the ID of the link over which to re-send the frame, if needed
      */
     virtual std::optional<uint8_t> ResendNotification(Ptr<const WifiMpdu> mpdu) = 0;
 
     /**
-     * \param linkId the ID of the given link
-     * \return the operating channel the main PHY must switch to in order to operate
+     * @param linkId the ID of the given link
+     * @return the operating channel the main PHY must switch to in order to operate
      *         on the given link
      */
     const WifiPhyOperatingChannel& GetChannelForMainPhy(uint8_t linkId) const;
 
     /**
-     * \param linkId the ID of the given link
-     * \return the operating channel an aux PHY must switch to in order to operate
+     * @param linkId the ID of the given link
+     * @return the operating channel an aux PHY must switch to in order to operate
      *         on the given link
      */
     const WifiPhyOperatingChannel& GetChannelForAuxPhy(uint8_t linkId) const;
@@ -314,14 +396,20 @@
     /**
      * Switch channel on the Main PHY so that it operates on the given link.
      *
-     * \param linkId the ID of the link on which the main PHY has to operate
-     * \param noSwitchDelay whether switching delay should be zero
-     * \param resetBackoff whether backoff should be reset on the link on which the main PHY
+     * @param linkId the ID of the link on which the main PHY has to operate
+     * @param noSwitchDelay whether switching delay should be zero
+     * @param resetBackoff whether backoff should be reset on the link on which the main PHY
      *                     is operating
-     * \param requestAccess whether channel access should be requested on the link on which the
+     * @param requestAccess whether channel access should be requested on the link on which the
      *                      main PHY is moving onto
+     * @param traceInfo information to pass to the main PHY switch traced callback (the fromLinkId
+     *                  and toLinkId fields are set by this function)
      */
-    void SwitchMainPhy(uint8_t linkId, bool noSwitchDelay, bool resetBackoff, bool requestAccess);
+    void SwitchMainPhy(uint8_t linkId,
+                       bool noSwitchDelay,
+                       bool resetBackoff,
+                       bool requestAccess,
+                       EmlsrMainPhySwitchTrace&& traceInfo);
 
     static constexpr bool RESET_BACKOFF = true;       //!< reset backoff on main PHY switch
     static constexpr bool DONT_RESET_BACKOFF = false; //!< do not reset backoff on main PHY switch
@@ -333,23 +421,31 @@
      * Switch channel on the Aux PHY operating on the given current link so that it operates
      * on the given next link.
      *
-     * \param auxPhy the Aux PHY
-     * \param currLinkId the ID of the link on which the aux PHY is currently operating
-     * \param nextLinkId the ID of the link on which the aux PHY will be operating
+     * @param auxPhy the Aux PHY
+     * @param currLinkId the ID of the link on which the aux PHY is currently operating
+     * @param nextLinkId the ID of the link on which the aux PHY will be operating
      */
     void SwitchAuxPhy(Ptr<WifiPhy> auxPhy, uint8_t currLinkId, uint8_t nextLinkId);
 
     /**
+     * Callback connected to the EmlsrLinkSwitch trace source of StaWifiMac.
+     *
+     * @param linkId the ID of the link involved in the EMLSR link switch event
+     * @param phy a pointer to the PHY involved in the EMLSR link switch event
+     */
+    virtual void EmlsrLinkSwitchCallback(uint8_t linkId, Ptr<WifiPhy> phy);
+
+    /**
      * Set the CCA ED threshold (if needed) on the given PHY that is switching channel to
      * operate on the given link.
      *
-     * \param phy the given PHY
-     * \param linkId the ID of the given link
+     * @param phy the given PHY
+     * @param linkId the ID of the given link
      */
     void SetCcaEdThresholdOnLinkSwitch(Ptr<WifiPhy> phy, uint8_t linkId);
 
     /**
-     * \return the EML Operating Mode Notification to send
+     * @return the EML Operating Mode Notification to send
      */
     MgtEmlOmn GetEmlOmn();
 
@@ -358,8 +454,8 @@
      * class when the EMLSR client gets channel access on the given link. This method has to
      * check possible reasons to give up the TXOP that apply to both main PHY and aux PHYs.
      *
-     * \param linkId the ID of the given link
-     * \return a pair consisting of a boolean value indicating whether the UL TXOP can be started
+     * @param linkId the ID of the given link
+     * @return a pair consisting of a boolean value indicating whether the UL TXOP can be started
      *         and a Time value indicating the delay after which the EMLSR client must restart
      *         channel access (if needed) in case the UL TXOP is not started
      */
@@ -371,8 +467,8 @@
      * an aux PHY that is not TX capable is operating. This method has to request the main PHY to
      * switch to the given link to take over the TXOP, unless it is decided to give up the TXOP.
      *
-     * \param linkId the ID of the given link
-     * \param aci the index of the given AC
+     * @param linkId the ID of the given link
+     * @param aci the index of the given AC
      */
     virtual void SwitchMainPhyIfTxopGainedByAuxPhy(uint8_t linkId, AcIndex aci) = 0;
 
@@ -383,29 +479,68 @@
      * given link to take over the TXOP, if possible, or determine the delay after which the
      * EMLSR client restarts channel access on the given link, otherwise.
      *
-     * \param linkId the ID of the given link
-     * \return a pair consisting of a boolean value indicating whether the UL TXOP can be started
+     * @param linkId the ID of the given link
+     * @return a pair consisting of a boolean value indicating whether the UL TXOP can be started
      *         and a Time value indicating the delay after which the EMLSR client must restart
      *         channel access (if needed) in case the UL TXOP is not started
      */
     virtual std::pair<bool, Time> GetDelayUnlessMainPhyTakesOverUlTxop(uint8_t linkId) = 0;
 
+    /**
+     * Set sleep state or awake state for all aux PHYs.
+     *
+     * @param sleep set sleep state, if true, or awake state, otherwise
+     */
+    void SetSleepStateForAllAuxPhys(bool sleep);
+
+    /**
+     * Cancel all pending events to put aux PHYs into sleep/awake state.
+     */
+    void CancelAllSleepEvents();
+
+    /**
+     * Get whether channel access is expected to be granted on the given link within the given
+     * delay to an Access Category that has traffic to send on the given link.
+     *
+     * @param linkId the ID of the given link
+     * @param delay the given delay
+     * @return whether channel access is expected to be granted on the given link within the given
+     *         delay
+     */
+    bool GetExpectedAccessWithinDelay(uint8_t linkId, const Time& delay) const;
+
+    /// Store information about a main PHY switch.
+    struct MainPhySwitchInfo
+    {
+        Time end;       //!< end of channel switching
+        uint8_t from{}; //!< ID of the link which the main PHY is/has been leaving
+        uint8_t to{};   //!< ID of the link which the main PHY is moving to
+    };
+
     Time m_emlsrPaddingDelay;    //!< EMLSR Padding delay
     Time m_emlsrTransitionDelay; //!< EMLSR Transition delay
     uint8_t m_mainPhyId; //!< ID of main PHY (position in the vector of PHYs held by WifiNetDevice)
     MHz_u m_auxPhyMaxWidth;                  //!< max channel width supported by aux PHYs
     WifiModulationClass m_auxPhyMaxModClass; //!< max modulation class supported by aux PHYs
     bool m_auxPhyTxCapable;                  //!< whether Aux PHYs are capable of transmitting PPDUs
+    bool m_auxPhyToSleep;     //!< whether Aux PHYs should be put into sleep mode while the Main PHY
+                              //!< is carrying out a (DL or UL) TXOP
+    bool m_useNotifiedMacHdr; //!< whether to use the information about the MAC header of
+                              //!< the MPDU being received (if notified by the PHY)
+    std::map<uint8_t, EventId> m_auxPhyToSleepEvents; //!< PHY ID-indexed map of events scheduled to
+                                                      //!< put an Aux PHY to sleep
+    std::map<uint8_t, Time> m_startSleep; //!< PHY ID-indexed map of last time sleep mode started
     std::map<uint8_t, EventId> m_ulMainPhySwitch; //!< link ID-indexed map of timers started when
                                                   //!< an aux PHY gains an UL TXOP and schedules
                                                   //!< a channel switch for the main PHY
+    MainPhySwitchInfo m_mainPhySwitchInfo;        //!< main PHY switch info
 
   private:
     /**
      * Set the ID of main PHY (position in the vector of PHYs held by WifiNetDevice). This
      * method cannot be called during or after initialization.
      *
-     * \param mainPhyId the ID of the main PHY
+     * @param mainPhyId the ID of the main PHY
      */
     void SetMainPhyId(uint8_t mainPhyId);
 
@@ -423,62 +558,60 @@
     void SendEmlOmn();
 
     /**
-     * Start the MediumSyncDelay timer and take the appropriate actions, if the timer is not
-     * already running.
+     * Start the MediumSyncDelay timer and take the appropriate actions.
      *
-     * \param linkId the ID of the link on which a TXOP was carried out that caused the STAs
-     *               operating on other links to lose medium synchronization
+     * @param linkId the ID of the link on which medium synchronization was lost
      */
     void StartMediumSyncDelayTimer(uint8_t linkId);
 
     /**
      * Take the appropriate actions when the MediumSyncDelay timer expires or is cancelled.
      *
-     * \param linkId the ID of the link associated with the MediumSyncDelay timer to cancel
+     * @param linkId the ID of the link associated with the MediumSyncDelay timer to cancel
      */
     void MediumSyncDelayTimerExpired(uint8_t linkId);
 
     /**
      * Notify the subclass of the reception of a management frame addressed to us.
      *
-     * \param mpdu the received MPDU
-     * \param linkId the ID of the link over which the MPDU was received
+     * @param mpdu the received MPDU
+     * @param linkId the ID of the link over which the MPDU was received
      */
     virtual void DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId) = 0;
 
     /**
      * Notify the subclass of the reception of an initial Control frame on the given link.
      *
-     * \param linkId the ID of the link on which the initial Control frame was received
+     * @param linkId the ID of the link on which the initial Control frame was received
      */
     virtual void DoNotifyIcfReceived(uint8_t linkId) = 0;
 
     /**
      * Notify the subclass of the start of an UL TXOP on the given link
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     virtual void DoNotifyUlTxopStart(uint8_t linkId) = 0;
 
     /**
      * Notify the subclass of the end of a TXOP on the given link.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     virtual void DoNotifyTxopEnd(uint8_t linkId) = 0;
 
     /**
      * Notify the acknowledgment of the given MPDU.
      *
-     * \param mpdu the acknowledged MPDU
+     * @param mpdu the acknowledged MPDU
      */
     void TxOk(Ptr<const WifiMpdu> mpdu);
 
     /**
      * Notify that the given MPDU has been discarded for the given reason.
      *
-     * \param reason the reason why the MPDU was dropped
-     * \param mpdu the dropped MPDU
+     * @param reason the reason why the MPDU was dropped
+     * @param mpdu the dropped MPDU
      */
     void TxDropped(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu);
 
@@ -502,12 +635,14 @@
     /**
      * Notify subclass that the main PHY is switching channel to operate on another link.
      *
-     * \param currLinkId the ID of the link on which the main PHY is operating (if any)
-     * \param nextLinkId the ID of the link on which the main PHY will be operating
-     * \param duration the channel switch duration
+     * @param currLinkId the ID of the link on which the main PHY is operating (if any)
+     * @param nextLinkId the ID of the link on which the main PHY will be operating
+     * @param auxPhy the aux PHY operating on the link on which the main PHY will be operating
+     * @param duration the channel switch duration
      */
     virtual void NotifyMainPhySwitch(std::optional<uint8_t> currLinkId,
                                      uint8_t nextLinkId,
+                                     Ptr<WifiPhy> auxPhy,
                                      Time duration) = 0;
 
     /**
@@ -520,6 +655,18 @@
                                               //!< MediumSyncDelay timer is running
     };
 
+    /**
+     * TracedCallback signature for main PHY switch events.
+     *
+     * @param info the information associated with the main PHY switch event
+     */
+    typedef void (*MainPhySwitchCallback)(const EmlsrMainPhySwitchTrace& info);
+
+    /// TracedCallback for main PHY switch events typedef
+    using MainPhySwitchTracedCallback = TracedCallback<const EmlsrMainPhySwitchTrace&>;
+
+    MainPhySwitchTracedCallback m_mainPhySwitchTrace; //!< main PHY switch trace source
+
     Ptr<StaWifiMac> m_staMac;                     //!< the MAC of the managed non-AP MLD
     std::optional<Time> m_emlsrTransitionTimeout; /**< Transition timeout advertised by APs with
                                                        EMLSR activated */
